##### wv׋23 5䗦ƕ\@R code #####

## Low Infant Birth Data ##

# birthwt2 ̏ #
library(MASS)
data(birthwt)
head(birthwt, n=2)

birthwt2 <- birthwt[, -10]		# bwt: ȍd
birthwt2$race <- factor(birthwt2$race, label=c("white", "black", "other"))	# q^ɕϊÃx1, 2, 3Awhite, black, otherɕύXB
birthwt2$ptl[birthwt2$ptl >= 1] <- "1+"		# ptl: 1ȏ̒l "1+" ƂB
birthwt2$ftv[birthwt2$ftv >= 1] <- "1+"		# ftv: 1ȏ̒l "1+" ƂB
head(birthwt2, n=2)

attach(birthwt2)	# birthwt2Ɋ܂܂ϐAʂɈ悤ɂB

# xƑΓx #
tbl <- table(race)	# x #
tbl

prop.table(tbl)		# Γx #

## event rate (person-time) : confidence interval and hypothesis testing ##

library(epitools)

##Examples from Rothman 1998, p. 238
bc <- c(Unexposed = 15, Exposed = 41)
pyears <- c(Unexposed = 19017, Exposed = 28010)
dd <- matrix(c(41,15,28010,19017),2,2)
dimnames(dd) <- list(Exposure=c("Yes","No"), Outcome=c("BC","PYears"))
dd

pois.exact(15,19117)
pois.exact(41,28010)

rateratio.wald(dd)



## Test of Proportion : proportions test with continuity correction
prop.test(96, 189, p=0.6)

## Test of Equal or Given Proportion : Clopper-Pearson exact confidence interval ##

binom.test(0, 10)



## \FAxAٓxAzIAAI ##

table(low, smoke)

library(pROC)

tbl.coords <- roc(low, smoke)

coords(tbl.coords, x="best", ret=c("accuracy", "1-sensitivity", "sensitivity", 
"1-specificity", "specificity", "ppv", "npv"))



## ROCȐAUC ##

library(pROC)

x <- c(1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1)		# :1CȂ:0
y <- c(0,0,0,0,0,0,0,0,0,0,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4)		# l
tbl <- table(x, y)
tbl

y2 <- rep((0:5), each=10)
tbl2 <- table(x, y2)
tbl2

tbl.roc <- roc(x, y)
plot(tbl.roc, print.auc=TRUE, print.thres=TRUE)				# ROCȐ̕`
opt.sp <- tbl.roc$sp[which.max(tbl.roc$se+tbl.roc$sp)]		# œKȓٓx
opt.se <- tbl.roc$se[which.max(tbl.roc$se+tbl.roc$sp)]		# œKȊx
abline((opt.sp+opt.se), -1)		# œKȃJbg|Cgʂ45x

tbl.roc2 <- roc(x, y2)
roc.test(tbl.roc, tbl.roc2)		# Compare the AUC of two ROC curves 

### Fisher̒ږ@ƃԓ挟 ###

tbl <- matrix(c(405, 173, 416, 152), 
				nrow=2, 
				dimnames=list("-Blocker" = c("(+)", "(-)"), 
							  "Olmesartan" = c("(+)", "(-)")))
tbl
fisher.test(tbl)				# Fisher̒ږ@
chisq.test(tbl)					# JC挟iA␳j
chisq.test(tbl, correct=FALSE)	# JC挟iA␳Ȃj

### McNemar ###

tbl2 <- matrix(c(175, 54, 16, 188), 
				nrow=2, 
				dimnames=list("2004 election" = c("Democrat", "Repablican"), 
							  "2008 election" = c("Democrat", "Repablican")))
tbl2
binom.test(16, (16 + 54))	# 񍀕zɂ鐳m
mcnemar.test(tbl2)			# McNemariA␳j
mcnemar.test(tbl2)			# McNemariA␳Ȃj

### Mantel-Haenszel ###

tbl3 <- array(c(80,160,16,160, 50, 10, 452, 452), dim=c(2,2,2))
tbl3
mantelhaen.test(tbl3)

### Cochran-Armitage Trend Test ###

tbl4 <- matrix(c(17066, 14464, 788, 126, 37, 48, 38, 5, 1, 1), 
				nrow=2, byrow=TRUE, 
				dimnames=list("Malformation" = c("Absent", "Present"), 
							  "Alcohol Consumption" = c("0", "< 1", "1-2", "3-5", ">= 6")))
tbl4
event <- tbl4[2, ]
total <- apply(tbl4, 2, sum)
prop.trend.test(event, total, score=c(0, 0.5, 1.5, 4.0, 7.0))		# Cochran-Armitage Trend Test
prop.test(event, total)				# iX́jƗ̌
